﻿Imports System
Imports System.Collections.Generic
Imports System.Text
'step1. reference nmodbuspc.dll, and using the namespaces.
Imports Modbus.Device      'for modbus master
Imports System.Net         'for tcp client
Imports System.Net.Sockets

Module input_status

    Private tcpClient As TcpClient
    Private master As ModbusIpMaster
    Sub main()

        ' connect to Modbus TCP Server
        Dim ipAddress As String = "127.0.0.1"   'Input WISE IP
        Dim tcpPort As Integer = 502
        Dim slaveID As Byte = 1
        tcpClient = New TcpClient(ipAddress, tcpPort)

        ' create Modbus TCP Master by the tcp client
        'document->Modbus.Device.Namespace->ModbusIpMaster Class->Create Method
        master = ModbusIpMaster.CreateIp(tcpClient)

        ' read the input status 20~29 (10020~10029, DI ch0 ~ ch9) of the WISE module.
        'document->Modbus.Device.Namespace->ModbusMaster Class->ReadInput Method                 
        Dim startAddress As UShort = 20
        Dim numOfPoints As UShort = 10
        master.Transport.ReadTimeout = 1000

        Try

            Dim status() As Boolean = master.ReadInputs(slaveID, startAddress, numOfPoints)
            For index As Integer = 0 To status.Length - 1
                Console.WriteLine(String.Format("DI[{0}] = {1}", index, status(index)))
            Next index

        Catch ex As Exception
            Console.WriteLine(ex.Message)
        End Try

        Console.WriteLine("Press enter to exit....")
        Console.ReadLine()
    End Sub
End Module
