Imports System
Imports System.Collections.Generic
Imports System.Text
'step1. reference nmodbuspc.dll, and using the namespaces.
Imports Modbus.Device      'for modbus master
Imports System.Net         'for tcp client
Imports System.Net.Sockets

Module Module1
    Public Declare Function InternetGetConnectedState Lib "wininet" (ByRef dwFlags As Long, ByVal dwReserved As Long) As Boolean
    Private tcpClient As TcpClient
    Private master As ModbusIpMaster
    Sub main()

        ' read the input register 20~29 (30020~30029) of the WISE module.
        'document->Modbus.Device.Namespace->ModbusMaster Class->ReadInputRegisters Method            
        Dim slaveID As Byte = 1
        Dim startAddress As UShort = 20
        Dim numOfPoints As UShort = 10
        Dim NetworkIsOk As Boolean
        NetworkIsOk = Connect()


        While True
            Try
                If NetworkIsOk Then
                    Dim register() As UShort = master.ReadInputRegisters(slaveID, startAddress, numOfPoints)
                    For index As Integer = 0 To register.Length - 1
                        Console.WriteLine(String.Format("register[{0}] = {1}", index, register(index)))
                    Next index
                Else
                    NetworkIsOk = Connect()
                    Console.WriteLine("Network:" + NetworkIsOk.ToString())

                End If
            Catch ex As Exception
                Console.WriteLine(ex.Message)
                NetworkIsOk = False
            End Try
        End While
    End Sub

    Private Function Connect() As Boolean
        Dim ipAddress As String
        Dim tcpPort As Integer

        ipAddress = "10.0.0.62" 'Input WISE IP
        tcpPort = 502
        If (master Is Nothing) Then

        Else
            master.Dispose()
        End If

        If (tcpClient Is Nothing) Then

        Else
            tcpClient.Close()
        End If


        If CheckInternet() = True Then
            Try

                tcpClient = New TcpClient(ipAddress, tcpPort)

                ' create Modbus TCP Master by the tcp client
                'document->Modbus.Device.Namespace->ModbusIpMaster Class->Create Method
                master = ModbusIpMaster.CreateIp(tcpClient)
                master.Transport.ReadTimeout = 1000
                Return True
            Catch ex As Exception
                Console.WriteLine(ex.StackTrace + "==>" + ex.Message)
                Return False
            End Try
        End If

        Return False
    End Function
    Private Function CheckInternet() As Boolean
        'http://msdn.microsoft.com/en-us/library/windows/desktop/aa384702(v=vs.85).aspx
        Dim INTERNET_CONNECTION_LAN As Long
        INTERNET_CONNECTION_LAN = 2
        Return InternetGetConnectedState(INTERNET_CONNECTION_LAN, 0)
    End Function

End Module
